ru.bitel.bgbilling.kernel.contract.autopayment.common.service

## Interface ContractAutopaymentService

-     public interface ContractAutopaymentService

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `autopaymentInvoke(int contractId, java.math.BigDecimal amount)`
    `SearchResult<Autopayment>` | `autopaymentSearch(int contractId, Period period, java.lang.String[] sort, Page page)`
    `void` | `contractAutopaymentModeCheck(int contractId, ContractAutopaymentMode autopaymentMode)` Проверка на возможность включения автоплатежа.
    `java.util.List<ContractAutopaymentMode>` | `contractAutopaymentModeList(int contractId)` Получение доступных режимов для договора.
    `boolean` | `isEnabled(int contractId)` Текущее состояние
    `SearchResult<ContractAutopayment>` | `searchContractAutopayment(int contractId, Period period, java.lang.String[] sort, Page page)` Список переключения разрешения/запрета автоплатежа администратором
    `boolean` | `setEnabled(int contractId, boolean enabled)` Установить состояние

- - ### Method Detail

    - #### searchContractAutopayment

          SearchResult<ContractAutopayment> searchContractAutopayment(int contractId,
                                                                      Period period,
                                                                      java.lang.String[] sort,
                                                                      Page page)
                                                               throws ru.bitel.bgbilling.common.BGException

      Список переключения разрешения/запрета автоплатежа администратором
      Parameters:
        `contractId` -
        `period` -
        `sort` -
        `page` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### isEnabled

          boolean isEnabled(int contractId)
                     throws ru.bitel.bgbilling.common.BGException,
                            ru.bitel.bgbilling.common.BGMessageException,
                            ru.bitel.bgbilling.common.BGIllegalArgumentException,
                            ru.bitel.bgbilling.common.BGIllegalAccessException

      Текущее состояние
      Parameters:
        `contractId` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### setEnabled

          boolean setEnabled(int contractId,
                             boolean enabled)
                      throws ru.bitel.bgbilling.common.BGException,
                             ru.bitel.bgbilling.common.BGMessageException,
                             ru.bitel.bgbilling.common.BGIllegalArgumentException,
                             ru.bitel.bgbilling.common.BGIllegalAccessException

      Установить состояние
      Parameters:
        `contractId` -
        `enabled` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractAutopaymentModeList

          java.util.List<ContractAutopaymentMode> contractAutopaymentModeList(int contractId)
                                                                       throws ru.bitel.bgbilling.common.BGException,
                                                                              ru.bitel.bgbilling.common.BGMessageException,
                                                                              ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                                                              ru.bitel.bgbilling.common.BGIllegalAccessException

      Получение доступных режимов для договора.
      Parameters:
        `contractId` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractAutopaymentModeCheck

          void contractAutopaymentModeCheck(int contractId,
                                            ContractAutopaymentMode autopaymentMode)
                                     throws ru.bitel.bgbilling.common.BGException,
                                            ru.bitel.bgbilling.common.BGMessageException,
                                            ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                            ru.bitel.bgbilling.common.BGIllegalAccessException

      Проверка на возможность включения автоплатежа.
      Parameters:
        `contractId` -
        `autopaymentMode` -
      Throws:
        `java.lang.Exception`
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### autopaymentSearch

          SearchResult<Autopayment> autopaymentSearch(int contractId,
                                                      Period period,
                                                      java.lang.String[] sort,
                                                      Page page)
                                               throws ru.bitel.bgbilling.common.BGException,
                                                      ru.bitel.bgbilling.common.BGMessageException,
                                                      ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                                      ru.bitel.bgbilling.common.BGIllegalAccessException

      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### autopaymentInvoke

          void autopaymentInvoke(int contractId,
                                 java.math.BigDecimal amount)
                          throws ru.bitel.bgbilling.common.BGException,
                                 ru.bitel.bgbilling.common.BGMessageException,
                                 ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                 ru.bitel.bgbilling.common.BGIllegalAccessException

      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`